/* Programme Démonstrateur pour mettre au point l'affichage du programme enregistré.

 Ce que fait ce démonstrateur :
 Il permet d'activer ou de suspendre les divers éléments affichés pour étudier l'effet visuel.
 Chaque séquence est évaluée en termes d'octets consommés pour pouvoir effectuer des choix de
 présentation dans le programme définitif. Enfin l'affichage étant géométriquement défini, on
 en déduit certaines coordonnées à respecter dans le logiciel principal, comme la position du
 code de consigne en bas à droite. Ainsi cet affichage sera compatible avec les écrans de base
 et celui spécifique au listage du programme enregistré en EEPROM.

                                                             PGM            RAM dynamique 
Affichage uniquement du cadre jaune et de son texte :  6170 Octets (20%)   128 Octets (6%)
Affichage de la grille :                               6364 Octets (20%)   128 Octets (6%) +194 octets
Affichage du n° de programme :                         6534 Octets (21%)   128 Octets (6%) +170 octets
Affichage de la consigne transmise à la sonde :        6566 Octets (21%)   128 Octets (6%)  +32 octets
Affichage des codes enregistrés :                      6974 Octets (22%)   130 Octets (6%) +408 octets
Barrer les cases :                                     7108 Octets (23%)   130 Octets (6%) +134 octets
Effacer les cases :                                    7330 Octets (23%)   130 Octets (6%) +222 octets

//--------------------- Déclarations pour le matériel ----------------------- */
#include <Adafruit_ssd1306syp.h> // Afficher graphique OLED.
// Définition des broches pour la ligne I2C.
#define broche_SDA 11 // D11 utilisée en sortie.
#define broche_SCL 12 // D12 utilisée en sortie.
// Initialisation des broches en sorties et affectations.
Adafruit_ssd1306syp display(broche_SDA, broche_SCL);
//------------------------- Variables du programme --------------------------
byte Code_PGM;
byte NB_Codes;

void setup()  {
  //------------------------ Initialisations pour le matériel --------------------------
  display.initialize(); delay(300); display.clear();
  //------------------------------ Affiche écran initial -------------------------------
  display.setTextSize(1); // Taille la plus petite.
  Affiche_cadre_du_haut(11); display.print("  TEST AFF PGM."); display.update();}
  
void loop() {
  AFF_grille_PGM();
  AFF_num_PGM();
  AFF_Code_Consigne(); 
  NB_Codes = 30; Code_PGM = 1;
  AFF_Codes_PGM();
  NB_Codes = 30;
//  Barre_Codes_PGM();
  NB_Codes = 30;
//  Efface_Codes_PGM();
  Infini : goto Infini;}
  
void AFF_grille_PGM() {
  CADRE(); for (byte C=16; C<113; C=C+16) display.drawLine(C, 17, C, 62, WHITE);
  for (byte L=15; L<63; L=L+12) display.drawLine(1, L, 127, L, WHITE); display.update();}
  
void AFF_Codes_PGM() {
  byte C=3; byte L=18;
  for (NB_Codes; NB_Codes>0; NB_Codes--) {
       display.setCursor(C,L); if (Code_PGM<10)display.print("0"); display.print(Code_PGM);
       L = L+12; if (L > 62) {L = 18; C = C+16;} Code_PGM++; display.update();}}

void Barre_Codes_PGM() {
  byte C=1; byte L=26;
  for (NB_Codes; NB_Codes>0; NB_Codes--) {
       display.drawLine(C, L, C+16, L-11, WHITE); delay(100); display.update();
       L = L+12; if (L > 62) {L = 26; C = C+16;}}}
       
void Efface_Codes_PGM() {
  byte C=1; byte L=17;
  for (NB_Codes; NB_Codes>0; NB_Codes--) {
       Effacer_zone(C,L,2); display.update(); delay(100); 
       L = L+12; if (L > 62) {L = 17; C = C+16;}}}
   
void AFF_num_PGM() {
  display.drawRect(114, 41, 13, 9, WHITE);
  display.drawRect(113, 40, 14, 11, WHITE);
  display.setCursor(115,42); display.setTextColor(BLACK, WHITE);
  display.print("P4"); display.setTextColor(WHITE, BLACK);}
  
void AFF_Code_Consigne() {// Simule un code su TX.
  display.setCursor(115,54); display.print("84"); display.update();}
  
//------------------------- Routines de servitude --------------------------  
void CADRE_UP() {display.drawRect(0, 0, 128, 16, WHITE);}
void CADRE() {display.drawRect(0, 16, 128, 48, WHITE);}
void Affiche_cadre_du_haut(byte X) {CADRE_UP(); display.setCursor(X,4);}
void Effacer_zone(byte X, byte Y, byte NB_caracteres) {
  byte I = 10; 
  for (byte J=0; J < I; J++)
       display.drawLine(X, Y + J, X + (NB_caracteres * 6), Y + J, BLACK);}

